trylink: instead of build error, disable --gc-sections if GLIBC && STATIC
[oweals/busybox.git] / scripts / trylink
1 #!/bin/sh
2
3 debug=false
4
5 # Linker flags used:
6 #
7 # Informational:
8 # --warn-common
9 # -Map $EXE.map
10 # --verbose
11 #
12 # Optimizations:
13 # --sort-common                 reduces padding
14 # --sort-section alignment      reduces padding
15 # --gc-sections                 throws out unused sections,
16 #                               does not work for shared libs
17 # -On                           Not used, maybe useful?
18 #
19 # List of files to link:
20 # $l_list                       == --start-group -llib1 -llib2 --end-group
21 # --start-group $O_FILES $A_FILES --end-group
22 #
23 # Shared library link:
24 # -shared                       self-explanatory
25 # -fPIC                         position-independent code
26 # --enable-new-dtags            ?
27 # -z,combreloc                  ?
28 # -soname="libbusybox.so.$BB_VER"
29 # --undefined=lbb_main          Seed name to start pulling from
30 #                               (otherwise we'll need --whole-archive)
31 # -static                       Not used, but may be useful! manpage:
32 #                               "... This option can be used with -shared.
33 #                               Doing so means that a shared library
34 #                               is being created but that all of the library's
35 #                               external references must be resolved by pulling
36 #                               in entries from static libraries."
37
38
39 try() {
40     printf "%s\n" "Output of:" >$EXE.out
41     printf "%s\n" "$*" >>$EXE.out
42     printf "%s\n" "==========" >>$EXE.out
43     $debug && echo "Trying: $*"
44     "$@" >>$EXE.out 2>&1
45     exitcode=$?
46     return $exitcode
47 }
48
49 check_cc() {
50     if $CC $1 -shared -o /dev/null -xc /dev/null >/dev/null 2>&1; then
51         echo "$1";
52     else
53         echo "$2";
54     fi
55 }
56
57 check_libc_is_glibc() {
58     local tempname="/tmp/temp.$$.$RANDOM.c"
59     echo "\
60         #include <stdlib.h>
61         /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
62         #if defined(__GLIBC__) && !defined(__UCLIBC__)
63         syntax error here
64         #endif
65         " >"$tempname"
66     if $CC "$tempname" -c -o /dev/null >/dev/null 2>&1; then
67         echo "$2";
68     else
69         echo "$1";
70     fi
71     rm "$tempname"
72 }
73
74 EXE="$1"
75 CC="$2"
76 LDFLAGS="$3"
77 O_FILES="$4"
78 A_FILES="$5"
79 LDLIBS="$6"
80
81 # The -Wl,--sort-section option is not supported by older versions of ld
82 SORT_SECTION=`check_cc "-Wl,--sort-section -Wl,alignment" ""`
83
84 # Static linking against glibc produces buggy executables
85 # (glibc does not cope well with ld --gc-sections).
86 # See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
87 # Note that glibc is unsuitable for static linking anyway.
88 # We are removing -Wl,--gc-sections from link command line.
89 GC_SECTION=`(
90 . ./.config
91 if test x"$CONFIG_STATIC" = x"y"; then
92     check_libc_is_glibc "" "-Wl,--gc-sections"
93 else
94     echo "-Wl,--gc-sections"
95 fi
96 )`
97
98 # Sanitize lib list (dups, extra spaces etc)
99 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
100
101 # First link with all libs. If it fails, bail out
102 echo "Trying libraries: $LDLIBS"
103 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
104 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
105 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
106 try $CC $LDFLAGS \
107         -o $EXE \
108         -Wl,--sort-common \
109         $SORT_SECTION \
110         $GC_SECTION \
111         -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
112         $l_list \
113 || {
114     echo "Failed: $* $l_list"
115     cat $EXE.out
116     exit 1
117 }
118
119 # Now try to remove each lib and build without it.
120 # Stop when no lib can be removed.
121 while test "$LDLIBS"; do
122     $debug && echo "Trying libraries: $LDLIBS"
123     all_needed=true
124     for one in $LDLIBS; do
125         without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
126         # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
127         l_list=`echo "$without_one" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
128         test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
129         $debug && echo "Trying -l options: '$l_list'"
130         try $CC $LDFLAGS \
131                 -o $EXE \
132                 -Wl,--sort-common \
133                 $SORT_SECTION \
134                 $GC_SECTION \
135                 -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
136                 $l_list
137         if test $? = 0; then
138             echo " Library $one is not needed"
139             LDLIBS="$without_one"
140             all_needed=false
141         else
142             echo " Library $one is needed"
143         fi
144     done
145     # All libs were needed, can't remove any
146     $all_needed && break
147     # If there is no space char, the list has just one lib.
148     # I'm not sure that in this case lib really is 100% needed.
149     # Let's try linking without it anyway... thus commented out.
150     #{ echo "$LDLIBS" | grep -q ' '; } || break
151 done
152
153 # Make the binary with final, minimal list of libs
154 echo "Final link with: ${LDLIBS:-<none>}"
155 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
156 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
157 # --verbose gives us gobs of info to stdout (e.g. linker script used)
158 if ! test -f busybox_ldscript; then
159     try $CC $LDFLAGS \
160             -o $EXE \
161             -Wl,--sort-common \
162             $SORT_SECTION \
163             $GC_SECTION \
164             -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
165             $l_list \
166             -Wl,--warn-common \
167             -Wl,-Map -Wl,$EXE.map \
168             -Wl,--verbose \
169     || {
170         cat $EXE.out
171         exit 1
172     }
173 else
174     echo "Custom linker script 'busybox_ldscript' found, using it"
175     # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
176     #  .rodata         : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
177     #  *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
178     #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
179     # This will eliminate most of the padding (~3kb).
180     # Hmm, "ld --sort-section alignment" should do it too.
181     try $CC $LDFLAGS \
182             -o $EXE \
183             -Wl,--sort-common \
184             $SORT_SECTION \
185             $GC_SECTION \
186             -Wl,-T -Wl,busybox_ldscript \
187             -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
188             $l_list \
189             -Wl,--warn-common \
190             -Wl,-Map -Wl,$EXE.map \
191             -Wl,--verbose \
192     || {
193         cat $EXE.out
194         exit 1
195     }
196 fi
197
198 . ./.config
199
200 sharedlib_dir="0_lib"
201
202 if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
203     mkdir "$sharedlib_dir" 2>/dev/null
204     test -d "$sharedlib_dir" || {
205         echo "Cannot make directory $sharedlib_dir"
206         exit 1
207     }
208     ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
209
210     EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
211     try $CC $LDFLAGS \
212             -o $EXE \
213             -shared -fPIC \
214             -Wl,--enable-new-dtags \
215             -Wl,-z,combreloc \
216             -Wl,-soname="libbusybox.so.$BB_VER" \
217             -Wl,--undefined=lbb_main \
218             -Wl,--sort-common \
219             $SORT_SECTION \
220             -Wl,--start-group $A_FILES -Wl,--end-group \
221             $l_list \
222             -Wl,--warn-common \
223             -Wl,-Map -Wl,$EXE.map \
224             -Wl,--verbose \
225     || {
226         echo "Linking $EXE failed"
227         cat $EXE.out
228         exit 1
229     }
230     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
231     chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
232     echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
233 fi
234
235 if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
236     EXE="$sharedlib_dir/busybox_unstripped"
237     try $CC $LDFLAGS \
238             -o $EXE \
239             -Wl,--sort-common \
240             $SORT_SECTION \
241             $GC_SECTION \
242             -Wl,--start-group $O_FILES -Wl,--end-group \
243             -L"$sharedlib_dir" -lbusybox \
244             -Wl,--warn-common \
245             -Wl,-Map -Wl,$EXE.map \
246             -Wl,--verbose \
247     || {
248         echo "Linking $EXE failed"
249         cat $EXE.out
250         exit 1
251     }
252     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
253     echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
254 fi
255
256 if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
257     echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
258     gcc -DNAME_MAIN_CNAME -E -include include/autoconf.h include/applets.h \
259     | grep -v "^#" \
260     | grep -v "^$" \
261     > applet_lst.tmp
262     while read name main junk; do
263
264         echo "\
265 void lbb_prepare(const char *applet, char **argv);
266 int $main(int argc, char **argv);
267
268 int main(int argc, char **argv)
269 {
270         lbb_prepare(\"$name\", argv);
271         return $main(argc, argv);
272 }
273 " >"$sharedlib_dir/applet.c"
274
275         EXE="$sharedlib_dir/$name"
276         try $CC $LDFLAGS "$sharedlib_dir/applet.c" \
277                 -o $EXE \
278                 -Wl,--sort-common \
279                 $SORT_SECTION \
280                 $GC_SECTION \
281                 -L"$sharedlib_dir" -lbusybox \
282                 -Wl,--warn-common \
283         || {
284             echo "Linking $EXE failed"
285             cat $EXE.out
286             exit 1
287         }
288         rm -- "$sharedlib_dir/applet.c" $EXE.out
289         $STRIP -s --remove-section=.note --remove-section=.comment $EXE
290
291     done <applet_lst.tmp
292 fi
293
294 # libbusybox.so is needed only for -lbusybox at link time,
295 # it is not needed at runtime. Deleting to reduce confusion.
296 rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
297 exit 0 # or else we may confuse make